From 3d7082366da50e6abd00a20b4b350b4ff6205231 Mon Sep 17 00:00:00 2001
From: Vincent Povirk <vincent@codeweavers.com>
Date: Tue, 23 Sep 2008 16:23:04 -0500
Subject: [PATCH] explorer: set the work area when appbars change

---
 programs/explorer/appbar.c |   39 +++++++++++++++++++++++++++++++++++++++
 1 files changed, 39 insertions(+), 0 deletions(-)

diff --git a/programs/explorer/appbar.c b/programs/explorer/appbar.c
index ca3698e..429b4b6 100644
--- a/programs/explorer/appbar.c
+++ b/programs/explorer/appbar.c
@@ -133,6 +133,41 @@ static void appbar_cliprect( HWND hwnd, RECT *rect )
     }
 }
 
+static void refresh_workarea(void)
+{
+    struct appbar_data* data;
+    RECT rc;
+
+    rc.left = 0;
+    rc.top = 0;
+    rc.right = GetSystemMetrics(SM_CXSCREEN);
+    rc.bottom = GetSystemMetrics(SM_CYSCREEN);
+
+    LIST_FOR_EACH_ENTRY(data, &appbars, struct appbar_data, entry)
+    {
+        if (data->space_reserved)
+        {
+            switch (data->edge)
+            {
+            case ABE_BOTTOM:
+                rc.bottom = min(rc.bottom, data->rc.top);
+                break;
+            case ABE_LEFT:
+                rc.left = max(rc.left, data->rc.right);
+                break;
+            case ABE_RIGHT:
+                rc.right = min(rc.right, data->rc.left);
+                break;
+            case ABE_TOP:
+                rc.top = max(rc.top, data->rc.bottom);
+                break;
+            }
+        }
+    }
+
+    SystemParametersInfoW(SPI_SETWORKAREA, 0, (void*)&rc, 0);
+}
+
 static UINT_PTR handle_appbarmessage(DWORD msg, struct appbar_data_msg *abd)
 {
     struct appbar_data* data;
@@ -167,6 +202,8 @@ static UINT_PTR handle_appbarmessage(DWORD msg, struct appbar_data_msg *abd)
             send_poschanged(hwnd);
 
             HeapFree(GetProcessHeap(), 0, data);
+
+            refresh_workarea();
         }
         else
             WINE_WARN("removing hwnd %p not on the list\n", hwnd);
@@ -194,6 +231,8 @@ static UINT_PTR handle_appbarmessage(DWORD msg, struct appbar_data_msg *abd)
             data->edge = abd->uEdge;
             data->rc = abd->rc;
             data->space_reserved = TRUE;
+
+            refresh_workarea();
         }
         else
         {
-- 
1.5.6.5

